#include "dialog.h"
#include "ui_dialog.h"
#include <QMessageBox>
#include <sstream>

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
}

Dialog::~Dialog()
{
    delete ui;
}

void Dialog::on_b_start_clicked()
{
    // Eingabe des Anwenders ermitteln...
    bool ok;
    int anzahl = ui->t_anzahl->text().toInt(&ok);
    if(!ok || anzahl < 2) return;

    // Zur Kontrolle: Ausgabe in Message-Box...
    std::ostringstream strm;
    strm << "Größe des Gitters: " << anzahl << " Schritte";

    QMessageBox box;
    box.setText(strm.str().c_str());
    box.exec();

//    // -----------------------------------------------------------------------
//    // Die folgende Variante, Solid Edge zu starten funktioniert nicht.
//    // ABER WARUM NUR...?!
//    //
//    // Zunächst sieht noch alles gut aus: Ein neuer Solid-Edge-Prozess
//    // wird gestartet, auch die if-Abfrage wird nicht ausgeführt.
//    QAxObject edge1;
//    edge1.setControl("SolidEdge.Application");
//    if(edge1.isNull())
//    {
//        QMessageBox err;
//        err.setText("Solid Edge nicht installiert?");
//        err.exec();
//        return;
//    }
//    //
//    // Die folgenden Aufrufe bringen aber dann eine Fehlermeldung:
//    // QAxBase: Error calling IDispatch member Visible: Unknown error
//    edge1.setProperty("Visible", true);
//    //
//    // Auch der folgende Aufruf liefert keine gültige Rückgabe:
//    // QAxBase: Error calling IDispatch member Documents: Member not found
//    QAxObject *docs = edge1.querySubObject("Documents");
//    // -----------------------------------------------------------------------

    // So funktioniert es dann doch: im Internet gefunden... :-)
    edge.setControl("SolidEdge.Application");
    if(edge.isNull())
    {
        QMessageBox err;
        err.setText("Solid Edge nicht installiert?");
        err.exec();
        return;
    }

    edge.setProperty("Visible", true);
    QAxObject *docs = edge.Documents();
    QAxObject *draft = docs->querySubObject("Add(QString)", "SolidEdge.DraftDocument");
    QAxObject *sheet = draft->querySubObject("ActiveSheet");
    QAxObject *lines2d = sheet->querySubObject("Lines2d");

    //double x1 = 0.1, y1 = 0.1;
    //double x2 = 0.2, y2 = 0.2;
    //lines2d->dynamicCall("AddBy2Points(double,double,double,double", x1, y1, x2, y2);
    //edge.dynamicCall("Quit(void)");

    // ----------------------------------------

    double start = 0.1, stopp = 0.3;
    double delta = (stopp - start) / (anzahl - 1);
    for(int i = 0; i < anzahl; ++i)
    {
        double x1 = start + i * delta, x2 = x1;
        double y1 = start, y2 = stopp;
        lines2d->dynamicCall("AddBy2Points(double,double,double,double", x1, y1, x2, y2);

        x1 = start, x2 = stopp;
        y1 = start + i * delta, y2 = y1;
        lines2d->dynamicCall("AddBy2Points(double,double,double,double", x1, y1, x2, y2);
    }
}
